#include <CITGroup.h>
#include <CITButton.h>
#include <CITFloat.h>

#include <stdlib.h>


CITApp Application;

CITWorkbench DemoScreen;
CITWindow    DemoWindow;
CITVGroup    winGroup;
CITButton    quitButton;
CITFloat     floatInput;

void CloseEvent();
void QuitEvent(ULONG ID);

int main(void)
{
  BOOL Error=FALSE;

  DemoScreen.InsObject(DemoWindow,Error);
    DemoWindow.Position(WPOS_CENTERSCREEN);
    DemoWindow.CloseGadget();
    DemoWindow.DragBar();
    DemoWindow.SizeGadget();
    DemoWindow.DepthGadget();
    DemoWindow.IconifyGadget();
    DemoWindow.Caption("Click to set");
    DemoWindow.CloseEventHandler(CloseEvent);
    DemoWindow.InsObject(winGroup,Error);
      winGroup.BevelStyle();
      winGroup.BevelLabel("A text");
      winGroup.InsObject(floatInput,Error);
        floatInput.LabelText("Indtast et tal:");
        floatInput.LabelJustification(LJ_RIGHT);
        floatInput.Number(3.14159);
        floatInput.MinVisible(10);
        floatInput.MaxChars(20);
      winGroup.InsObject(quitButton,Error);
        quitButton.Text("Quit");
        quitButton.EventHandler(QuitEvent);

  Application.InsObject(DemoScreen,Error);

  // Ok?
  if( Error )
    return 11;

  Application.Run();

  Application.RemObject(DemoScreen);
  return 0;
}

void QuitEvent(ULONG ID)
{
  Application.Stop();
}


int repeatCount = 0;

void CloseEvent()
{
  repeatCount++;

  switch( repeatCount )
  {
    case 1:
      floatInput.Number(27.12345);
      break;
    default:
      Application.Stop();
    break;
  }
}
